; punkoe
; affichage.asm - gestion de l'affichage du jeu

  section ".text"

  xdef    Afficher
  xdef    PatchEcran

  include "punkoe.h"

; Afficher
; Affiche le jeu (map, perso, barre de saut)
Afficher:

  bsr.s   AfficherMap

  bsr     AfficherPerso

  bsr     AfficherBarre

; Actualisation de l'ecran
  moveq.l #(30*96)/(4*6)-1,d0
PatchEcran:
  move.w  #$4C00,a1
  \CopyScr:
    move.l  (a0)+,(a1)+
    move.l  (a0)+,(a1)+
    move.l  (a0)+,(a1)+
    move.l  (a0)+,(a1)+
    move.l  (a0)+,(a1)+
    move.l  (a0)+,(a1)+
    dbf     d0,\CopyScr
  rts

; AfficherMap
; Affiche la map (ecrase ce qu'il y avait a l'ecran)
; ! Considere que les fonctions PutClipVTile16x8 et ClearRect160x16 ne
; detruisent pas a2 !
AfficherMap:

  movea.l a6,a0 ; a0 = dest
  movea.l a5,a2 ; a2 = map

  move.w  hcam_mod24(a4),d0
  subi.w  #24,d0 ; d0 = y
  \PourChaqueLigne:
    moveq.l #0,d1
    \PourChaqueColonne:
      clr.w   d2
      move.b  (a2)+,d2
      lsl.w   #4,d2
      lea.l   TabTiles(pc),a1
      adda.w  d2,a1
      bsr.s   PutClipVTile16x8
      addi.w  #16,d1
      cmpi.w  #160,d1
      blt.s   \PourChaqueColonne
    addq.w    #8,d0
    bsr.s     ClearRect160x16
    addi.w    #16,d0
    cmpi.w    #96,d0
    blt.s     \PourChaqueLigne
  rts

; PutClipVTile16x8
; Affiche un tile 16x8 aux coordonnes indiques.
; Clipping vertical seulement
; Remplace compltement la destination
; Input :
; d0.w : y
; d1.w : x
; a0.l : dest
; a1.l : tile
; Dtruit : d2-d3/a1
PutClipVTile16x8:
  move.l  a0,-(a7)
  moveq.l #7,d3 ; hauteur du sprite

  move.w  d1,d2
  lsr.w   #4,d2
  add.w   d2,d2
  adda.w  d2,a0 ; dest += 2*(x/16)

; Clipping vertical
  tst.w   d0
  bpl.s   \TestBottom
; y<0
    cmpi.w  #-8,d0
    ble.s   \EndPutClipVTile16x8 ; y<= -8
    add.w   d0,d3
    suba.w  d0,a1
    suba.w  d0,a1
    moveq.l #0,d2
    bra.s   \AddVOffset
\TestBottom:
  moveq.l #96-8,d2
  sub.w   d0,d2 ; d2 = 96-8 - y
  bpl.s   \CalculVOffset
    cmpi.w  #-8,d2
    ble.s   \EndPutClipVTile16x8 ; 96-8 - y <= 8
    add.w   d2,d3 ; h += 96-8-y
\CalculVOffset:
  move.w  d0,d2
  lsl.w   #5,d2 ; d2 = y*32
  sub.w   d0,d2
  sub.w   d0,d2 ; d2 = y*30
\AddVOffset:
  adda.w  d2,a0 ; a0 += 30*y

  \LoopPutClipVTile16x8:
    move.w  (a1)+,(a0)
    lea.l   30(a0),a0
    dbf     d3,\LoopPutClipVTile16x8

\EndPutClipVTile16x8:
  movea.l (a7)+,a0
  rts

; ClearRect160x16
; Efface un rectangle de 160x16 pixels
; Paramtres :
; d0 : y
; a0 : dest
; Dtruit : d2-d3
ClearRect160x16:
  move.l  a0,-(a7)

  moveq.l #16,d2 ; d2 = h

  tst.w   d0
  bpl.s   \ClippingBas
    add.w   d0,d2
    beq.s   \FinClearRect160x16
    moveq.l #0,d3 ; d3 = offset
    bra.s   \AjouteOffset

\ClippingBas:
  cmpi.w  #96-16,d0
  bls.s   \CalculOffset ; si y <= 96-16
    moveq.l #96,d2
    sub.w   d0,d2 ; d2 = h
    bls.s   \FinClearRect160x16

\CalculOffset:
  move.w  d0,d3
  lsl.w   #5,d3
  sub.w   d0,d3
  sub.w   d0,d3 ; d3 = y*30

\AjouteOffset:
  adda.w  d3,a0

  subq.w  #1,d2

  moveq.l #0,d3

  \LoopClearRect160x16:
    move.l  d3,(a0)+
    move.l  d3,(a0)+
    move.l  d3,(a0)+
    move.l  d3,(a0)+
    move.l  d3,(a0)+
    lea.l   10(a0),a0
    dbf     d2,\LoopClearRect160x16

\FinClearRect160x16
  movea.l (a7)+,a0
  rts

; AfficherPerso
; Affiche le personnage
; Paramtres : a0 = dest
; Dtruit : d0-d2/a1
AfficherPerso:
  moveq.l #96-10,d0
  sub.w   d6,d0
  add.w   d7,d0 ; d0 = 96 - 10 - hperso + hcam = y
  move.w  xperso(a4),d1 ; d1 = x
  moveq.l #7,d2
  and.w   d1,d2 ; d2 = x&7
  mulu.w  #10,d2
  tst.w   dirperso(a4)
  bmi.s   \DirPersoOK
    addi.w  #8*10,d2
\DirPersoOK:
  lea.l   TabSprtPerso(pc),a1 ; a1 = sprt
  adda.w  d2,a1
;  bra.s   PutClipVSprite8x10

; PutClipVSprite8x10
; Affiche un sprite 8x10 avec clipping vertical
; Paramtres :
; d0.w : y
; d1.w : x
; a0 : dest
; a1 : sprt
; Dtruit : d0-d3/a1-a2
PutClipVSprite8x10:
  move.l  a0,a2
  moveq.l #10-1,d3

  move.w  d1,d2
  lsr.w   #4,d2
  add.w   d2,d2
  adda.w  d2,a2 ; a2 += x/8

  tst.w   d0
  bpl.s   \TestBottom
  ; y<0
    cmpi.w  #-10,d0
    ble.s   \EndPutClipVSprite8x10
    suba.w  d0,a1
    add.w   d0,d3
    moveq.l #0,d2
    bra.s   \AddVOffset
\TestBottom:
  moveq.l #96-10,d2
  sub.w   d0,d2 ; d2 = 96 - 10 - y
  bpl.s   \CalculVOffset
    cmpi.w  #-10,d2
    ble.s   \EndPutClipVSprite8x10
    add.w   d2,d3
\CalculVOffset:
  add.w   d0,d0
  move.w  d0,d2
  lsl.w   #4,d2
  sub.w   d0,d2
\AddVOffset:
  adda.w  d2,a2 ; dest += y*30

  moveq.l #24,d0
  andi.w  #15,d1
  sub.w   d1,d0

\LoopPutClipVSprite8x10:
  moveq.l #0,d1
  move.b  (a1)+,d1
  lsl.l   d0,d1
  or.l    d1,(a2)
  lea.l   30(a2),a2
  dbf     d3,\LoopPutClipVSprite8x10

\EndPutClipVSprite8x10:
  rts

; AfficherBarre
; Affiche la barre de saut
; Paramtres : d4 : remplissage de la barre
; Dtruit : d0
AfficherBarre:
  moveq.l #-1,d0
  lsr.l   d4,d0
  move.l  d0,0*30(a0)
  move.l  d0,1*30(a0)
  move.l  d0,2*30(a0)
  move.l  d0,3*30(a0)
  rts
